/***********************************************************************/
/*                                                                     */
/* parseini.hpp: Header file for INI file parser                       */
/*                                                                     */
/*               Copyright (c) Yak! 2005 All rights reserved.          */
/*                                                                     */
/*   $URL: svn://localhost/afxspdir/trunk/parseini.hpp $               */
/*  $Date: 2005-11-14 20:00:34 +0900 (Mon, 14 Nov 2005) $              */
/*   $Rev: 53 $                                                        */
/*                                                                     */
/***********************************************************************/

#ifndef PARSEINI_HPP
#define PARSEINI_HPP

#include <iostream>
#include <string>
#include <vector>
#include <map>

#include <boost/algorithm/string/split.hpp>
#include <boost/algorithm/string/classification.hpp>

class ParseINI
{
public:
	template<typename Range>
	ParseINI(const Range &rInput)
	{
		typedef std::vector<std::string> SplitLineType;
		SplitLineType vsLines;
		boost::algorithm::split(vsLines, rInput, boost::algorithm::is_any_of("\r\n") );
		for(SplitLineType::const_iterator ci = vsLines.begin(); ci != vsLines.end(); ++ci) {
std::cerr << "*ci:" << *ci << std::endl;
			std::string::size_type sPos;
			sPos = ci->find_first_of(';');
			if(sPos == std::string::npos) {
				sPos = ci->size();
			}
			const std::string sValid = ci->substr(0, sPos);
std::cerr << "sValid:" << sValid << std::endl;
			if(sValid.size() > 2 && sValid.at(0) == '[' && *--(sValid.end()) == ']') {
				sType = sValid.substr(1, sValid.size()-2);
			} else if((sPos = sValid.find_first_of('=')) != std::string::npos) {
				mConf[sValid.substr(0, sPos)] = sValid.substr(sPos + 1);
std::cerr << getValue(sValid.substr(0, sPos)) << std::endl;
			} else if(sValid.size() != 0) { // Ignore blank line
std::cerr << "Unrecognized line occurs at line " << ci - vsLines.begin() + 1 << " , contents are `" << *ci << '\'' << std::endl;
				// TODO: should throw
			}
		}
	}
	const std::string& getType(void) const { return sType; }
	const std::string& getValue(const std::string& sKey) const { if(isExist(sKey)) return mConf.find(sKey)->second; throw 1; /* TODO: throw properly exception */ }
	bool isExist(const std::string& sKey) const { return mConf.find(sKey) != mConf.end(); }
private:
	std::string sType;
	std::map<std::string, std::string> mConf;
};

#endif
